CREATE TABLE IF NOT EXISTS `discussions` (
  `id`            mediumint(8) unsigned             NOT NULL AUTO_INCREMENT,
  `dkid` 	  tinyint(3) unsigned   	    NOT NULL DEFAULT '1',
  `stoid` 	  mediumint(8) unsigned 	    NOT NULL DEFAULT '0',
  `sid` 	  varchar(16)  			    NOT NULL DEFAULT '',
  `title` 	  varchar(128) 			    NOT NULL DEFAULT '',
  `url` 	  mediumtext,
  `topic` 	  int(10) unsigned		    DEFAULT NULL,
  `ts` 		  datetime 			    NOT NULL DEFAULT '1900-01-01 00:00:00',
  `type` 	  enum('open','recycle','archived') NOT NULL DEFAULT 'open',
  `uid` 	  mediumint(8) unsigned 	    NOT NULL DEFAULT '0',
  `commentcount`  smallint(5) unsigned 		    NOT NULL DEFAULT '0',
  `flags` 	  enum('ok','delete','dirty') 	    NOT NULL DEFAULT 'ok',
  `primaryskid`   smallint(5) unsigned 		    DEFAULT NULL,
  `last_update`   timestamp   			    NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `approved` 	  tinyint(3) unsigned 		    NOT NULL DEFAULT '0',
  `commentstatus` enum('disabled','enabled','friends_only','friends_fof_only','no_foe','no_foe_eof','logged_in') NOT NULL DEFAULT'enabled',
  `archivable`    enum('no','yes')     		    NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`id`),
  KEY `stoid` (`stoid`),
  KEY `sid` (`sid`),
  KEY `topic` (`topic`),
  KEY `primaryskid` (`primaryskid`,`ts`),
  KEY `type` (`type`,`uid`,`ts`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC
