CREATE TABLE IF NOT EXISTS `submissions` (
  `subid`       mediumint(8) unsigned                       NOT NULL AUTO_INCREMENT,
  `email`       varchar(255)                                NOT NULL DEFAULT '',
  `emaildomain` varchar(255)                                NOT NULL DEFAULT '',
  `name`        varchar(50)                                 NOT NULL DEFAULT '',
  `time`        datetime                                    NOT NULL DEFAULT '1970-01-01 00:00:00',
  `subj`        varchar(80)                                 NOT NULL,
  `story`       mediumtext                                  NOT NULL,
  `tid`         int(10) unsigned                            NOT NULL,
  `note`        varchar(30)                                 NOT NULL DEFAULT '',
  `primaryskid` smallint(5) unsigned                        DEFAULT NULL,
  `comment`     varchar(255)                                NOT NULL DEFAULT '',
  `uid`         mediumint(8) unsigned                       NOT NULL DEFAULT '0',
  `ipid`        varchar(32)                                 NOT NULL DEFAULT '',
  `subnetid`    varchar(32)                                 NOT NULL DEFAULT '',
  `del`         tinyint(4)                                  NOT NULL DEFAULT '0',
  `weight`      float                                       NOT NULL DEFAULT '0',
  `signature`   varchar(32)                                 NOT NULL DEFAULT '',
  `mediatype`   enum('none','text','video','image','audio') NOT NULL DEFAULT 'none',
  PRIMARY KEY            (`subid`),
  UNIQUE KEY             `signature` (`signature`),
  KEY `del`              (`del`),
  KEY `uid`              (`uid`),
  KEY `emaildomain`      (`emaildomain`),
  KEY `time_emaildomain` (`time`,`emaildomain`),
  KEY `ipid`             (`ipid`),
  KEY `subnetid`         (`subnetid`),
  KEY `primaryskid_tid`  (`primaryskid`,`tid`),
  KEY `tid`              (`tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC
