CREATE TABLE IF NOT EXISTS `users_info` (
  `uid`                 mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `totalmods`           mediumint(9)                              NOT NULL DEFAULT '0',
  `realname`            varchar(50)                               DEFAULT NULL,
  `bio`                 mediumtext                                NOT NULL,
  `tokens`              mediumint(9)                              NOT NULL DEFAULT '0',
  `lastgranted`         datetime                                  NOT NULL DEFAULT '1900-01-01 00:00:00',
  `m2info`              varchar(64)                               NOT NULL DEFAULT '',
  `karma`               mediumint(9)                              NOT NULL DEFAULT '0',
  `maillist`            tinyint(4)                                NOT NULL DEFAULT '0',
  `totalcomments`       mediumint(8) unsigned                     DEFAULT '0',
  `lastm2`              datetime                                  NOT NULL DEFAULT '1970-01-01 00:00:00',
  `m2_mods_saved`       varchar(120)                              NOT NULL DEFAULT '',
  `lastaccess`          date                                      NOT NULL DEFAULT '1970-01-01',
  `m2fair`              mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `up_fair`             mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `down_fair`           mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `m2unfair`            mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `up_unfair`           mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `down_unfair`         mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `m2fairvotes`         mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `m2voted_up_fair`     mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `m2voted_down_fair`   mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `m2unfairvotes`       mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `m2voted_up_unfair`   mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `m2voted_down_unfair` mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `m2voted_lonedissent` mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `m2voted_majority`    mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `upmods`              mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `downmods`            mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `stirred`             mediumint(8) unsigned                     NOT NULL DEFAULT '0',
  `session_login`       tinyint(4)                                NOT NULL DEFAULT '0',
  `cookie_location`     enum('classbid','subnetid','ipid','none') NOT NULL DEFAULT 'none',
  `registered`          tinyint(3) unsigned                       NOT NULL DEFAULT '1',
  `reg_id`              varchar(32)                               NOT NULL DEFAULT '',
  `expiry_days`         mediumint(9)                              NOT NULL DEFAULT '1',
  `expiry_comm`         mediumint(9)                              NOT NULL DEFAULT '1',
  `user_expiry_days`    smallint(5) unsigned                      NOT NULL DEFAULT '1',
  `user_expiry_comm`    smallint(5) unsigned                      NOT NULL DEFAULT '1',
  `initdomain`          varchar(30)                               NOT NULL DEFAULT '',
  `created_ipid`        varchar(32)                               NOT NULL DEFAULT '',
  `created_at`          datetime                                  NOT NULL DEFAULT '1900-01-01 00:00:00',
  `tag_clout`           float unsigned                            NOT NULL DEFAULT '1',
  `people`              mediumblob,                               
  `people_status`       enum('ok','dirty')                        NOT NULL DEFAULT 'ok',
  `csq_bonuses`         float                                     NOT NULL DEFAULT '0',
  PRIMARY KEY         (`uid`),
  KEY `people_status` (`people_status`),
  KEY `initdomain`    (`initdomain`),
  KEY `created_ipid`  (`created_ipid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC
