package Newslash::Model::Urls;
use Newslash::Model::Base -base;
use Newslash::Model::LegacyDB;

use Digest::MD5 qw(md5_hex);

sub select {
    my $self = shift;
    my $unique_keys = { id => "urls.url_id",
                        url_id => "urls.url_id" };
    return $self->generic_select(table => "urls",
                                 unique_keys => $unique_keys,
                                 params => {@_});
}

sub create {
    my $self = shift;
    my $params = {@_};

    my $url = $params->{url};
    return if !$url;

    return $self->getUrlCreate($params);
}

sub hard_delete {
    my $self = shift;
    my $params = {@_};

    my $id = $params->{id} || $params->{url_id};
    return if !$id;

    my $error = 0;
    my $sql = "DELETE FROM urls WHERE url_id = ?";
    my $dbh = $self->connect_db;
    my $rs = $dbh->do($sql, undef, $id);
    if (!defined $rs || $rs == 0) {
        Mojo::Log->new->warn("DELETE FROM urls failed. id is $id.");
        $error = 1;
    }
    $self->disconnect_db;
    return !$error;
}


## WORNING:
## This is worst legacy from slash. deprecated, and you can use only backword-compatible.

sub getUrlIfExists {
    my ($self, $url) = @_;
    my $md5 = md5_hex($url);

    my $db = Newslash::Model::LegacyDB->new($self->{options});
    my $urlid = $db->sqlSelect("url_id", "urls", "url_digest = '$md5'");
    return $urlid;
}

sub createUrl {
    my ($self, $data) = @_;
    $data ||= {};
    $data->{url_digest} = md5_hex($data->{url});
    $data->{'-createtime'} = 'NOW()';

    my $db = Newslash::Model::LegacyDB->new($self->{options});
    $db->sqlInsert("urls", $data);
    my $id = $db->getLastInsertId();
    return $id;
}

sub getUrlCreate {
    my($self, $data) = @_;
    $data ||= {};
    return 0 if !$data->{url};
    my $id = $self->getUrlIfExists($data->{url});
    return $id if $id;
    return $self->createUrl($data);
}



1;
