package Newslash::Model::Users::Friends;
use Newslash::Model::Base -base;

sub _get_friends {
    my $self = shift;
    my $uid = shift;
    my $type = shift;
    my $perceive = shift;
    return if !$uid;

    my $and_clause = "";
    if ($type) {
        $and_clause = 'people.type = ?';
    }
    elsif ($perceive) {
        $and_clause = 'people.perceive = ?';
    }

    my $sql = <<"EOSQL";
SELECT users.* FROM users
  JOIN people ON users.uid = people.person
  WHERE people.uid = ? AND $and_clause
EOSQL

    my $dbh = $self->connect_db;
    my $sth = $dbh->prepare($sql);;
    if ($type) {
        $sth->execute($uid, $type);
    }
    elsif ($perceive) {
        $sth->execute($uid, $perceive);
    }

    my $rs = $sth->fetchall_arrayref({});
    $self->disconnect_db;
    return if !$rs;

    my $users = $self->new_instance_of('Users');

    my @result = map { $users->_create_user_object($_) } @$rs;
    $users->get_user_config(\@result);

    return \@result;
}


sub friends {
    my $self = shift;
    my $params = {@_};
    return $self->_get_friends($params->{uid}, 'friend', '');
}

sub foes {
    my $self = shift;
    my $params = {@_};
    return $self->_get_friends($params->{uid}, 'foe', '');
}

sub fans {
    my $self = shift;
    my $params = {@_};
    return $self->_get_friends($params->{uid}, '', 'fan');
}

sub freaks {
    my $self = shift;
    my $params = {@_};
    return $self->_get_friends($params->{uid}, '', 'freak');
}

1;
