package Newslash::Model::Users::Auth;
use Newslash::Model::Base -base;

use Digest::MD5 qw(md5_hex md5_base64);
use Crypt::Eksblowfish::Bcrypt qw(bcrypt en_base64 de_base64);


# This module is depradated. Use Passwords.pm.


#========================================================================

=head2 authentification

  my $result = $users->password->authentification($nickname, $password);

Return 1 when nickname and password pair is correct.

=cut

sub authentification {
    my ($self, $nickname, $passwd) = @_;
    my $users = $self->new_instance_of("Users");

    my $dbh = $self->connect_db;
    my $sql = "SELECT * FROM users WHERE nickname = ?";
    my $sth = $dbh->prepare($sql);

    $sth->execute($nickname);

    my $rs = $sth->fetchall_arrayref(+{});
    $sth->finish;
    $self->disconnect_db();
    if (@$rs == 0) {
        return undef;
    }
    my $u = $rs->[0];

    if ($self->comparePassword($passwd, $u->{passwd}, $u->{uid}, 0, 0)) {
        return $users->select(uid => $u->{uid});
    }
    return;
}

=head2 comparePassword(PASSWD, MD5, ISPLAIN, ISENC)

(imported from Slash)

Given a password and an MD5 hex string, compares the two to see if they
represent the same value.  To be precise:

If the password given is equal to the MD5 string, it must already be
in MD5 format and be correct, so return true

Otherwise, the password is assumed to be plaintext.  Each possible
salt-encryption of it (including the encryption with empty salt) is
compared against the MD5 string.  True is returned if there is any
match.

If ISPLAIN is true, PASSWD is assumed to be plaintext, so the
(trivial equality) test against the encrypted MD5 is not performed.

If ISENC is true, PASSWD is assumed to be already encrypted, so the
tests of salting and encrypting it are not performed.

(If neither is true, all tests are performed.  If both are true, no
tests are performed and 0 is returned.)

=over 4

=item Parameters

=over 4

=item PASSWD

Possibly-correct password, either plaintext or already-MD5's,
to be checked.

=item MD5

Encrypted correct password.

=back

=item Return value

0 or 1.

=back

=cut

sub comparePassword {
  my ($self, $passwd, $md5, $uid, $is_plain, $is_enc) = @_;

  if (!$is_plain) {
    return 1 if $passwd eq $md5;
  }
  if (!$is_enc) {
    # An old way of encrypting a user's password, which we have
    # to check for reverse compatibility.
    return 1 if md5_hex($passwd) eq $md5;

    # check password hash with Bcrypt
    if ($md5 =~ m/\$2a?\$\d{2}\$.+/) {
        return 10 if $md5 eq bcrypt($passwd, $md5);
    }

    my $salt_ar = $self->_get_salt;

    # No?  OK let's see if it matches any of the salts.
    #my $slashdb = getCurrentDB();
    #my $vu = $slashdb->{virtual_user};
    #my $salt_ar = Slash::Apache::User::PasswordSalt::getPwSalts($vu);
    unshift @$salt_ar, ''; # always test the case of no salt
    for my $salt (reverse @$salt_ar) {
      # The current way of encrypting a user's password.
      return 1 if md5_hex("$salt:$uid:$passwd") eq $md5;
      # An older way, which we have to check for reverse
      # compatibility.
      return 1 if length($salt) && md5_hex("$salt$passwd") eq $md5;
    }
  }
  return 0;
}

sub _get_salt {
    return [];
}

1;

