package Newslash::Plugin::RequestBodyCondition;
use Mojo::Base 'Mojolicious::Plugin';
use Data::Dumper;

sub register {
    my ($self, $app, $conf) = @_;
    $self->{app} = $app;

    $app->routes->add_condition(request_body => sub {
                                    my ($route, $c, $captures, $cond) = @_;
                                    my $params = $c->req->json;
                                    return if !$params;

                                    for my $k (keys %$cond) {
                                        return if !$params->{$k};
                                        return if $params->{$k} ne $cond->{$k};
                                    }

                                    return 1;
                                });
}

1;
