package Newslash::Util;

use strict;
use warnings;
use utf8;
use feature ':5.10';

use Exporter 'import';

our @EXPORT_OK = qw(load_config);
use Data::Dumper;
use DateTime;
use DateTime::Format::MySQL;
use YAML qw(LoadFile);

use constant CONF_PATH => "/etc/newslash/newslash.conf";


sub load_config {
    my $self = shift;
    my $config_file = shift;
    $config_file = CONF_PATH if !$config_file;

    my $config = eval { LoadFile($config_file) };
    die qq{Can't parse config "$config_file": $@} if $@;
    die qq{Invalid config "$config_file"} unless ref $config eq 'HASH';

    return $config;
}

1;
