package Newslash::Util::Items;

use strict;
use warnings;
use utf8;
use feature ':5.10';

use Data::Dumper;
use DateTime;
use DateTime::Format::MySQL;

sub get_date_string_from_item {
    my ($self, $item, $offset_sec, $unit) = @_;
    return if !$item;
    $offset_sec ||= 0;

    my $dt = DateTime::Format::MySQL->parse_datetime($item->{create_time});
    return if !$dt;

    $dt->add(seconds => $offset_sec) if ($offset_sec != 0);

    my ($yyyy, $mm, $dd) = ($dt->year, $dt->month, $dt->day);
    my $yy = substr($yyyy, 2);
    $mm = "0$mm" if $mm < 10;
    $dd = "0$dd" if $dd < 10;

    if ($unit eq "year") {
        return "$yy";
    }
    elsif ($unit eq "month") {
        return "$yy/$mm";
    }
    return "$yy/$mm/$dd";
}


1;
