package Newslash::Web::Controller::API::Metamoderation;
#use Mojo::Base 'Mojolicious::Controller';
use Mojo::Base 'Newslash::Web::Controller';
use Mojo::Util qw(dumper);
use Mojo::JSON qw(decode_json encode_json to_json from_json);

sub get {
    my $c = shift;
    my $user = $c->stash('user');
    my $metamoderations = $c->model('metamoderations');

    my $message = "";
    my $cid = $c->req->param("cid");

    if (!$cid) {
        $message = "valid cid is required";
    }
    else {
        my $m2s = $metamoderations->select(cid => $cid);
        $c->apply_seclev_filter("metamoderation", $m2s);

        if ($m2s) {
            my $hashed_m2s = {};
            for my $m2 (@$m2s) {
                if (!defined $hashed_m2s->{$m2->{mmid}}) {
                    $hashed_m2s->{$m2->{mmid}} = [];
                }
                push @{$hashed_m2s->{$m2->{mmid}}}, $m2;
            }
            $c->render(json => {cid => $cid,
                                metamoderations => $hashed_m2s});
            return;
        }
        $message = "moderations cannot retrive";
    }

    if (length($message) > 0) {
        $c->render(json => { error => 1, message => $message });
        $c->rendered(400);
        return;
    }
    return;
}

sub post {
    my $c = shift;
    my $user = $c->stash('user');
    my $metamoderations = $c->model('metamoderations');

    my $data = $c->req->json;
    my $message = "invalid request";

    if (!$user->{is_login}) {
        $c->render(json => { error => 1, message => "you are not a valid user." });
        $c->rendered(400);
        return;
    }

    if ($data->{action} eq "metamoderate") {
        my $mod_id = $data->{moderation_id};
        my $value = $data->{value};

        if ($mod_id && defined $value) {
            my $m2id = $metamoderations->create($user, $mod_id, $value);
            if ($m2id) {
                $c->render(json => {message => "metamoderation accepted"});
                $c->event_que->emit("metamoderation", "post", $user->{uid}, $m2id);
                $c->stats->add_event_counter("metamoderation");
                return;
            }
            $c->render(json => { error => 1, message => $metamoderations->last_error });
            $c->rendered(400);
            return;
        }
    }

    $c->render(json => { error => 1, message => $message });
    $c->rendered(400);
    return;
}

1;
