package Newslash::Web::Controller::API::Token;
use Mojo::Base 'Mojolicious::Controller';
use Mojo::Util qw(dumper);
use Mojo::JSON qw(decode_json encode_json to_json from_json);

sub get {
    my $c = shift;
    my $user = $c->stash('user');
    my $moderations = $c->model('moderations');

    my $message = "";
    my $rc_str = $c->req->param("rc");

    if (!$rc_str) {
        $message = "invalid request";
    }
    else {
        my $session = $c->session('session');
        my $token = $c->anti_csrf->get_token($rc_str, $session->{token});
        if ($token) {
            $c->render(json => {token => $token});
            return;
        }
        $message = "token cannot retrive";
    }

    if (length($message) > 0) {
        $c->render(json => { error => 1, message => $message });
        $c->rendered(400);
        return;
    }
    return;
}

1;
