package Newslash::Web::Controller::Admin::Config;
use Mojo::Base 'Mojolicious::Controller';
use Mojo::Util qw(dumper);


sub cache {
    my $c = shift;
    my $user = $c->stash('user');
    my $new_status = $c->param('disable');
    my $return_path = $c->param('r') || "/";


    if (!$user || !$user->{uid}) {
        $c->rendered(500);
        return;
    }
    if ($new_status ne "0" && $new_status ne "1") {
        $c->rendered(400);
        return;
    }
    my $users = $c->model('users');
    my $ret = $users->configs->update(id => $user->{uid},
                                      system => {disable_cache => $new_status});
    if (!$ret) {
        $c->rendered(500);
        return;
    }

    # update cache
    $c->user_auth->update_user_cache($user);
    # ok, send redirect response
    $c->res->code(302);
    $c->redirect_to($return_path);
    return;
}

1;

