package Newslash::Web::Controller::Hof;
use Mojo::Base 'Mojolicious::Controller';
use Data::Dumper;

sub hof {
    my $c = shift;
    my $range = 1;

    my $stories = $c->model('stories');

    my $stories_by_comments = $stories->select(limit => 10,
                                               order_by => { commentcount => "DESC" });
    my $stories_by_comments_annual = $stories->select(limit => 10,
                                                      order_by => { commentcount => "DESC" },
                                                      years => $range,
                                                     );

    my $stories_by_hits = $stories->select(limit => 10,
                                           order_by => { hits => "DESC" });
    my $stories_by_hits_annual = $stories->select(limit => 10,
                                                  order_by => { hits => "DESC" },
                                                  years => $range,
                                                 );

    my $submissions = $c->model('submissions');

    my $users_by_submits = $submissions->count_by_author(limit => 11);
    my $users_by_submits_annual = $submissions->count_by_author(limit => 11, years => $range);

    my $polls = $c->model('polls');

    my $polls_by_voters = $polls->select(limit => 10,
                                        order_by => { voters => "DESC" });
    my $polls_by_voters_annual = $polls->select(limit => 10,
                                               order_by => { voters => "DESC" },
                                               years => $range);

    my $journals = $c->model('journals');
    my $journals_by_entries = $journals->count_by_author(limit => 10);
    my $journals_by_entries_annual = $journals->count_by_author(limit => 10, years => $range);

    $c->render(page => { type => "hof" },
               top_story_by_comments => $stories_by_comments,
               top_story_by_comments_annual => $stories_by_comments_annual,
               top_story_by_hits => $stories_by_hits,
               top_story_by_hits_annual => $stories_by_hits_annual,
               top_submitter => $users_by_submits,
               top_submitter_annual => $users_by_submits_annual,
               top_polls => $polls_by_voters,
               top_polls_annual => $polls_by_voters_annual,
               top_journalists => $journals_by_entries,
               top_journalists_annual => $journals_by_entries_annual,
              );
}


1;

