package Newslash::Web::Controller::My;
use Mojo::Base 'Mojolicious::Controller';
use Mojo::Util qw(dumper);

sub messages {
    my $c = shift;
    my $user = $c->stash('user');
    my $messages = $c->model('web_messages')->select(uid => $user->{uid});
    $c->render(items => $messages);
};

sub settings {
    my $c = shift;
    my $user = $c->stash('user');

    $c->render(email => $user->{realemail});
}

sub change_email {
    my $c = shift;
    my $user = $c->stash('user');

    my $users = $c->model('users');
    my $token = $c->param("token");
    my $cancel = $c->param("cancel");

    # if reset token
    if ($cancel) {
        my $rs = $c->users->cancel_change_email_request($user->{uid});
        if (!$rs) {
            $c->render(error => $c->users->last_error);
            $c->res->code(400);
            return;
        }
        $c->render(succeed => 1, canceled => 1);
        return;
    }


    my $rs = $c->users->verify_and_change_email($user->{uid}, $token);
    if (!$rs) {
        $c->render(error => $c->users->last_error || "ERROR");
        $c->res->code(400);
        return;
    }

    # ok
    $c->render(succeed => 1);
    return;
}

1;

