/* ad-codes-editor.js */
const adCodesEditor = {};

adCodesEditor.run = function run (params) {
  var vm;
  const data = {
    message: '',
    adCodes: [],
    selected: {},
    edited: true,
  };
  const watch = {
  };
  
  const computed = {};
  const methods = {
    saveItem: function saveItem(target) {
      if (!target.ad_id && target.ad_id !== 0) {
        this.message = "save_failed";
        return;
      }
      
      const reqData = {
        name: target.name,
        description: target.description,
        status: target.status,
        content: target.content,
      };
      if (target.ad_id) {
        reqData.ad_id = target.ad_id;
      }

      newslash.admin.updateADCodes(reqData).then(
        (resp) => { // success
          target.ad_id = resp.id;
          this.message = "saved";
        },
        (resp) => { // fail
          this.message = "save_failed";
        }
      );
    },

    deleteItem: function deleteItem(target) {
      if (!target.ad_id && target.ad_id !== 0) {
        this.message = "save_failed";
        return;
      }
      const pos = this.adCodes.indexOf(target);
      if (target.ad_id === 0) {
        this.adCodes.splice(pos, 1);
        this.message = "deleted";
        return;
      }

      newslash.admin.deleteADCodes(target.ad_id).then(
        (resp) => { // success
          this.adCodes.splice(pos, 1);
          this.message = "deleted";
        },
        (resp) => { // fail
          this.message = "delete_failed";
        }
      );
    },
    addItem: function addItem() {
      const item = {
        ad_id: 0,
        name: 'new item',
        description: '',
        enabled: true,
        status: 'enabled',
        content: '',
      };
      this.adCodes.push(item);
    },
  };

  function initItems (items) {
    items.forEach(item => {
      Vue.set(item, 'enabled', item.status == "enabled");
    });
  };

  vm = new Vue({el: params.el,
                data: data,
                computed: computed,
                methods: methods,
                watch: watch,

                created: function onCreate() {
                  newslash.admin.getADCodes().then(
                    (resp) => { // success
                      this.adCodes = resp.items || [];
                      this.message = resp.message || '';
                      initItems(this.adCodes);
                    },
                    (resp) => { // fail
                      this.adCodes = [];
                      this.message = resp.message || "failed to get AD codes";
                    }
                  );

                },
               });
};
