/* dom-util.js - dom related utility functions */
'use strict';

var domUtil = {};

domUtil.addEventListenerById = function addEventListenerById (id, type, listener, options) {
  var elem = document.getElementById(id);
  if (!elem) {
    console.log("domUtil.addEventListenerById: no match id");
    return;
  }
  elem.addEventListener(type, listener, options);
};

domUtil.addEventListenerByClass = function addEventListenerByClass (klass, type, listener, options) {
  if (!klass || (!typeof klass == "string" && !typeof klass == "number")) {
    console.log("domUtil.addEventListenerByClass: invalid classe given");
    return;
  };
  
  var elems = document.getElementsByClassName(klass);
  if (!elems) {
    console.log("domUtil.addEventListenerByClass: no match class");
    return;
  }

  for (var i = 0; i < elems.length; i++) {
    elems[i].addEventListener(type, listener, options);
  }
};

domUtil.toggleClassById = function toggleClassById(id, klass) {
  var elem = document.getElementById(id);
  if (!elem) {
    console.log("domUtil.toggleClassByUd: no match id");
    return;
  }
  elem.classList.toggle(klass);
};

