/* users-manager.js */
const usersManager = {vm: {}};

usersManager.run = function run (params) {
  
  const data = {
    message: '',
    userName: "",
    user: {
      uid: "",
      nickname: "",
      realemail: "",
      homepage: "",
      sig: "",
      seclev: 0,
      author: 0,
      acl2: {values: []},
      acl2_log: [],
      activities: {},
    },
    urls: {
      get: '/api/v1/user',
      post: '/api/v1/user',
    },
    queryed: false,
    acl2Comment: "",
    showProfile: false,
    showACL2: false,
    showACTS: false,
    acl2Types: acl2Types,
  };
  const computed = {
    isAuthor: function () {return this.user.is_author == 1;},
  };

  const methods = {
    getUserInfo: getUserInfo,
    saveACL2: saveACL2,
  };

  function getUserInfo() {
    var url;
    var srcid;
    if (/^\d{1,6}$/.test(this.userName)) {
      url = this.urls.get + "?type=all&uid=" + this.userName;
    } else if (/^[0-9a-fA-F]{32}$/.test(this.userName)) {
      url = this.urls.get + "?type=all&srcid=" + this.userName;
    } else if (/^[0-9a-fA-F]{16}$/.test(this.userName)) {
      url = this.urls.get + "?type=all&srcid=" + this.userName;
    } else {
      url = this.urls.get + "?type=all&nickname=" + this.userName;
    }
    statusBar.loading('loading...');
    this.$http.get(url).then(
      (resp) => { // success
        this.queryed = true;
        this.user = resp.body.item || {};
        statusBar.hide();
      },
      (resp) => { // fail
        this.message = resp.body.message || "failed to get items";
        statusBar.error(resp.body.message || "failed to get items");
      }
    );
  }

  function saveACL2() {
    var url = this.urls.post;
    statusBar.loading('loading...');
    var data = {
      type: "acl2",
      uid: this.user.uid,
      values: this.user.acl2.values,
      comment: this.acl2Comment,
    };
    this.$http.post(url, data).then(
      (resp) => { // success
        statusBar.done('saved');
      },
      (resp) => { // fail
        this.message = resp.body.message || "failed to update";
        statusBar.error(resp.body.message || "failed to update");
      }
    );
  }

  this.vm = new Vue({el: params.el,
                     data: data,
                     computed: computed,
                     methods: methods,
                     created: created,
                    });

  function created() {
    if (params.uid) {
      this.userName = params.uid;
      this.getUserInfo();
    } else if (params.nickname) {
      this.userName = params.nickname;
      this.getUserInfo();
    } else if (params.srcid) {
      this.userName = params.srcid;
      this.getUserInfo();
    }
  }

};
