# -*- coding: utf-8 -*-
'''exceptions: define exceptions'''

class NewslashIndexError(Exception):
    def __str__(self):
        return self.message


class ConfigFileError(NewslashIndexError):
    SECTION_NOT_FOUND = "Section not found"
    PARAMETER_NOT_FOUND = "Parameter not found"
    def __init__(self, reason, section=""):
        self.message = "Config Error - {}: {}".format(reason, section)


class DocumentMakingError(NewslashIndexError):
    def __init__(self, message="error while document making"):
        self.message = message


class DatabaseError(NewslashIndexError):
    def __init__(self, message="datagbase error"):
        self.message = message
