#!/bin/sh
#IMAGE=jessie_mojolicious
IMAGE=stretch_mojolicious
DEV_DIR=${HOME}/mojolicious/src
CONTAINER_NAME=mojolicious
SD_MASTER=sradcompose_slash_1
SD_DB=sradcompose_srad-db_1
NETWORK=--network=srad_test
CMD="/var/newslash/newslash_web/script/newslash_web daemon"
CAP="--memory=2gb"
CERTS_DIR="/etc/letsencrypt"
MOUNT_CERTS="-v ${CERTS_DIR}:/var/certs"
ENV_OPT="-e MOJO_LISTEN=https://*:3000?cert=/var/certs/live/sdtest.osdn.co.jp/cert.pem&key=/var/certs/live/sdtest.osdn.co.jp/privkey.pem"
OPTS="$CAP --link $SD_DB:sd-db --link newslash-db --link newslash-redis --link $SD_MASTER:sd-master -v ${DEV_DIR}:/var/newslash ${MOUNT_CERTS} -p 3000:3000 --name $CONTAINER_NAME $ENV_OPT $NETWORK"
docker rm $CONTAINER_NAME
if [ $# -eq 0 ]; then
	docker run -ti $OPTS $IMAGE $CMD
else
	docker run -ti $OPTS $IMAGE "$@"
fi


